/*
 * (C)opyright 2006 Nico Golde <nico@ngolde.de>
 * (C)opyright 2006 Andreas Krennmair <ak@synflood.at>
 * See LICENSE file for license details
 */

#ifndef CONN__H
#define CONN__H

#include <stdint.h>
#include <sys/types.h>

enum { CONN_PLAIN = 0, CONN_SSL, CONNTYPE_MAX = 2 };

typedef struct {
	unsigned short type;
	int fd;
	void * hndl;
} conn_t;

conn_t * connect_plain(char * ip, uint16_t port);
conn_t * connect_ssl(char * ip, uint16_t port);
void disconnect(conn_t * );

int conn_read(conn_t * conn, char * buf, size_t bufsize);
int conn_readline(conn_t * conn, char * buf, size_t bufsize);
int conn_write(conn_t * conn, char * buf, size_t bufsize);

#endif
