/*
 * (C)opyright 2006 Nico Golde <nico@ngolde.de>
 * (C)opyright 2006 Andreas Krennmair <ak@synflood.at>
 * See LICENSE file for license details
 */

#include "http.h"
#include <stdio.h>
#include <string.h>
#include <stdlib.h>


static inline int getstatus (char * buf){
	char *tmp;
	if((tmp=strchr(buf, ' '))!=NULL){
		*tmp=0;
		tmp++;
		return strtol(tmp, NULL, 10);
	}
	else
		return 404;
}

int parse_http (char * buf){
	char *srvstring;
	int code = 404;
	if((srvstring = malloc(129))==NULL){
		perror("malloc");
		exit(EXIT_FAILURE);
	}
	if(!strncasecmp("HTTP/1.0", buf, 8))
		sscanf(buf, "HTTP/1.0 %128s", srvstring);
	else if(!strncasecmp("HTTP/1.1", buf, 8))
		sscanf(buf, "HTTP/1.1 %128s", srvstring);
	else
		return NOT_RELEVANT;

	code=strtol(srvstring, NULL, 10);
	free(srvstring);
	return code;
}

char * get_service (char * buf){
	char *tmp;
	if((tmp = strchr(buf, ' '))!=NULL){
		*tmp = 0;
		tmp++;
		return tmp;
	}
	else
		return NULL;
}

static char * fake_ua = "Mozilla/4.0 (compatible ; MSIE 6.0; Windows NT 5.1)";

void send_head_request(conn_t * conn, url_t * url, char * word, unsigned long flags) {
	char buf[2048];
	snprintf(buf,sizeof(buf),"HEAD %s%s/ HTTP/1.0\r\nUser-Agent: %s\r\nHost: %s:%u\r\nConnection: %s\r\n\r\n", 
		url->resource, word, (flags & FAKE_UA) ? fake_ua : "w3bfukk0r " VERSION, 
		url->host, url->port, (flags & KEEPALIVE) ? "Keep-Alive" : "close");
	conn_write(conn,buf,strlen(buf));
}
