/*
 * (C)opyright 2006 Nico Golde <nico@ngolde.de>
 * (C)opyright 2006 Andreas Krennmair <ak@synflood.at>
 * See LICENSE file for license details
 */

#ifndef LIST__H
#define LIST__H

typedef struct word {
	char * word;
	struct word * next;
} word_t;

typedef struct {
	word_t * top;
	word_t * last;
	unsigned long count;
} wordlist_t;

wordlist_t * new_wordlist(void);
void delete_list(wordlist_t *);
void append_word(wordlist_t * list, char * word);
void fill_wordlist_from_file(wordlist_t * list, char * filename);

word_t * get_top(wordlist_t * list);

#define FOREACH_WORD(list,wordname,block) \
	do { \
		word_t * e = list->top; char * wordname; \
		for (e=list->top;e;e=e->next) { wordname = e->word; \
		{ block } \
		} \
	} while (0)

#endif
