/*
 * (C)opyright 2006 Nico Golde <nico@ngolde.de>
 * (C)opyright 2006 Andreas Krennmair <ak@synflood.at>
 * See LICENSE file for license details
 */

#ifndef URL_H
#define URL_H

#include <stdint.h>
#include <sys/types.h>

typedef enum { 
	PROTO_INVALID = -1, 
	PROTO_HTTP = 0, 
	PROTO_HTTPS 
} proto_t;

typedef struct {
	proto_t protocol;
	char *host;
	uint16_t port;
	char *resource;
} url_t;

url_t * parse_url(char * name);
void free_url(url_t *);
void url_to_str(char * str, size_t n, url_t * url);

#endif
